;;; smilisp.el --- Smilisp Emotional Fontification Support

;; Copyright (C) 2009 Didier Verna

;; Author:        Didier Verna <didier@lrde.epita.fr>
;; Maintainer:    Didier Verna <didier@lrde.epita.fr>
;; Created:       Wed Apr  1 00:00:00 2009
;; Last Revision: Wed Apr  1 23:59:59 2009
;; Keywords:      lisp, data


;; This file is part of Smilisp.

;; Smilisp is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2 of the License, or
;; (at your option) any later version.

;; Smilisp is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program; if not, write to the Free Software
;; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


;;; Commentary:

;; Contents management by FCM version 0.1.


;;; Code:

(require 'smiley)

(defmacro with-smilisp-smileys (&rest body)
  "Execute BODY with the proper Smilisp smileys."
  `(let ((smiley-regexp-alist '((":[o-](" 0 "sad") (":[-o])" 0 "smile")))
	 smiley-cached-regexp-alist)
    ,@body))

(defun smilisp-region (start end)
  "Smilispify the region between START and END."
  (interactive "r")
  (with-smilisp-smileys
   (smiley-region start end)))

(defun smilisp-buffer (&optional buffer)
  "Smilispify BUFFER."
  (interactive "bBuffer to smilispify ")
  (with-smilisp-smileys
   (smiley-buffer buffer)))


;;; smilisp.el ends here
