;;; smilisp.lisp --- Common Lisp Implementation

;; Copyright (C) 2008 Didier Verna

;; Author:        Didier Verna <didier@lrde.epita.fr>
;; Maintainer:    Didier Verna <didier@lrde.epita.fr>
;; Created:       Wed Apr  1 00:00:00 2009
;; Last Revision: Wed Apr  1 23:59:59 2009


;; This file is part of Smilisp.

;; Smilisp is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2 of the License, or
;; (at your option) any later version.

;; Smilisp is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program; if not, write to the Free Software
;; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


;;; Commentary:

;; Contents management by FCM version 0.1.


;;; Code:

(defun |:-reader| (s |:|)
  (declare (ignore |:|))
  (let ((nose (read-char s t nil t)))
    (case nose
      ((#\- #\o)
       (let ((mouth (peek-char nil s t nil t)))
	 (case mouth
	   ((#\( #\))
	    (values))
	   (otherwise
	    (intern (concatenate 'string
		      (make-string 1 :initial-element (char-upcase nose))
		      (symbol-name (read s t nil t)))
		    :keyword)))))
      (otherwise
       (unread-char nose s)
       (intern (symbol-name (read s t nil t)) :keyword)))))

(set-macro-character #\: #'|:-reader| :non-terminating)


;;; smilisp.lisp ends here
